package com.base.api.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class SceneTargetPointRpcDTO {

    /**
     * 所属目标，外键target_id
     */
    private String targetId;

    /**
     * 顶点编码
     */
    private String pointCode;

    /**
     * 维度
     */
    private BigDecimal latitude;

    /**
     * 经度
     */
    private BigDecimal longitude;

    /**
     * 顶点连接顺序，从0开始，不包括中心点（中心点为-1）
     */
    private Integer sequence;

    /**
     * 创建时间
     */
    private Date createdDate;

    /**
     * 创建人
     */
    private String createdBy;

    /**
     * 最后修改人
     */
    private String lastModifiedBy;

    /**
     * 最后修改时间
     */
    private Date lastModifiedDate;

    /**
     * 版本号
     */
    private BigDecimal version;

    /**
     * 状态
     */
    private BigDecimal status;

    @TableId(value = "id", type = IdType.AUTO)
    private String id;

    /**
     * 数据来源0，初始导入；1，页面新增
     */
    private Integer source;


}
