package com.base.biz.model;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
public class PointDTO {

    @ApiModelProperty("点Id")
    private String pointId;
    @ApiModelProperty("顶点连接顺序，从0开始，不包括中心点（中心点为-1）")
    private Integer sequence;
    @ApiModelProperty("纬度")
    private Double lat;
    @ApiModelProperty("经度")
    private Double lng;

    /**
     * 动目标平均航速，单位节，1节=1海里/小时=1.852km/h
     */
    @ApiModelProperty("动目标平均航速")
    private String movingEvgSpeed;

    /**
     * 航向
     */
    private String heading;

    /**
     * 移动时长
     */
    private String time;

}
