package com.base.biz.model.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
@TableName("payload_info")
public class PayloadInfo {

    @TableId
    private String id;
    @ApiModelProperty("卫星id")
    private String satelliteId;
    @ApiModelProperty("卫星编号")
    private String satelliteCode;
    @ApiModelProperty("载荷名称")
    private String payloadName;
    @ApiModelProperty("载荷类型 1可见光/微光 2红外 3微波 4SAR 5掩星")
    private String payloadType;
    @ApiModelProperty("载荷工作模式")
    private String payloadWorkModes;
    @ApiModelProperty("载荷系列")
    private String payloadSeries;
    @ApiModelProperty("分辨率 单位米")
    private Double groundResolution;
    @ApiModelProperty("幅宽，单位米")
    private Double swathWidth;
    @ApiModelProperty("最小太阳高度角")
    private String minSunElevation;
    @ApiModelProperty("最大太阳高度角")
    private String maxSunElevation;
    @ApiModelProperty("视场角")
    private String fox;
    @ApiModelProperty("模式")
    private String model;
    @ApiModelProperty("载荷状态")
    private String payloadStatus;
    @ApiModelProperty("创建时间")
    private Date createTime;
    @ApiModelProperty("修改时间")
    private Date updateTime;
    @ApiModelProperty("地面站录放比")
    @TableField(value = "dm_playback_ratio")
    private Double dmPlaybackRatio;
    @ApiModelProperty("中继星录放比")
    @TableField(value = "zj_playback_ratio")
    private Double zjPlaybackRatio;
    @ApiModelProperty("幅宽重叠区域，单位km，双载荷有意义")
    private Double overLap;
    @ApiModelProperty("载荷速率")
    @TableField(value = "data_pass_speed")
    private String dataPassSpeed;
    /**
     * 类型，0光学，1红外，2电子，3雷达，4通信，5导航
     */
    private String type;
}
