package com.base.orbit.Exception;

import lombok.Builder;
import lombok.Data;

import java.util.List;

/**
 * 服务
 *
 * @author jhzhu
 * @date 2022-02-12
 */
@Data
@Builder
public class Service {

    /** 服务编码 */
    private String code;
    /** 服务名称 */
    private String name;
    /** 包含的模块 */
    private List<Module> modules;

    /**
     * 服务中的模块
     *
     * @author jhzhu
     * @date 2022-02-12
     */
    @Data
    @Builder
    public static class Module {

        /** 所属服务 */
        private Service service;
        /** 模块编码 */
        private String code;
        /** 模块名称 */
        private String name;

    }
}
