package com.base.core.config;

import lombok.Data;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
@Data
public class StripAccessConfig {

    /**
     * 计算侧摆角方法，由degree_mothod和piece_mothod
     */
    @Value("${parameter.ppaspara.rollanglemethod}")
    private String rollAngleMethod;
    /**
     * 侧摆角间隔角度，单位度
     */
    @Value("${parameter.ppaspara.degreeSplit}")
    private Double degreeSplit;
    /**
     * 侧摆角份数
     */
    @Value("${parameter.ppaspara.pieceCount}")
    private Integer pieceCount;

    /**
     * 最小网格数量
     */
    @Value("${parameter.ppaspara.minGridCount}")
    private Integer minGridCount;

    /**
     * 单次开机最长时长
     */
    @Value("${parameter.ppaspara.maxWindowLimit}")
    private String maxWindowLimit;

    /**
     * 最大海拔限制
     */
    @Value("${parameter.ppaspara.maxAlt}")
    private String maxAlt;

    /**
     * 最大观测时长
     */
    @Value("${parameter.ppaspara.maxDuration}")
    private String maxDuration;

    /**
     * 最小观测时长
     */
    @Value("${parameter.ppaspara.minDuration}")
    private String minDuration;

    /**
     * 最小观测时长
     */
    @Value("${parameter.ppaspara.realDuration}")
    private Integer realDuration;

}
