package com.base.plan.model.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;
import java.util.Set;

@Data
public class TaskStripOptimizationRes {

    /**
     * 需求id
     */
    private String reqId;

    /**
     * 该需求的状态，最高优先级判断（0，正在优选，1，优选完成）
     */
    private Integer areaOptimizationState;

    private String targetCode;

    private String targetName;

    /**
     * 需求优先级，次优先级判断
     */
    private Integer priority;

    /**
     * 目标区域覆盖网格
     */
    private Set<String> targetGirdCodeList;

    /**
     * 该任务所有相关的条带
     */
    private List<StripDTO> stripDTOList;

    /**
     * 所有能拍到该目标的方案
     */
    private List<SinglePlan> singlePlanList;

    @ApiModelProperty("卫星code")
    private String satelliteCode;

    @ApiModelProperty("仿真任务开始时间")
    private Date startTime;
    @ApiModelProperty("仿真任务结束时间")
    private Date endTime;

}