package com.base.plan.model.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

@Data
public class WindowStripDTO {

    @ApiModelProperty("窗口Id")
    private String id;
    @ApiModelProperty("卫星名称")
    private String satelliteName;
    @ApiModelProperty("覆盖率")
    private String sideSwayValue;
    @ApiModelProperty("访问时刻")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date accessTime;
    @ApiModelProperty("通过时长")
    private String accessDuration;
    @ApiModelProperty("分辨率")
    private Float resolvingPower;
    @ApiModelProperty("条带附加信息")
    private List<SubStripDTO> subStripList;

}
