package com.base.plan.model.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 
 * </p>
 *
 * @author cxl
 * @since 2022-06-24
 */
@Getter
@Setter
@TableName("alg_scheme_step_window")  // 筹划方案
@ApiModel(value = "AlgSchemeStepWindow对象", description = "")
@AllArgsConstructor
@NoArgsConstructor
public class AlgSchemeStepWindow implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("uuid")
    @TableId("id")
    private String id;

    @ApiModelProperty("方案需求uuid")
    @TableField("scheme_step_id")
    private String schemeStepId;

    @ApiModelProperty("窗口选用失败原因")
    @TableField("window_failed_reason")
    private String windowFailedReason;

    @ApiModelProperty("创建时间")
    @TableField("created_date")
    private Date createdDate;

    @ApiModelProperty("创建人")
    @TableField("created_by")
    private String createdBy;

    @ApiModelProperty("最后修改人")
    @TableField("last_modified_by")
    private String lastModifiedBy;

    @ApiModelProperty("最后修改时间")
    @TableField("last_modified_date")
    private Date lastModifiedDate;

    @ApiModelProperty("卫星ID")
    @TableField("satellite_id")
    private String satelliteId;

    @ApiModelProperty("卫星CODE")
    @TableField("satellite_code")
    private String satelliteCode;

    @ApiModelProperty("开始时间")
    @TableField("start_time")
    private Date startTime;

    @ApiModelProperty("结束时间")
    @TableField("end_time")
    private Date endTime;

    @ApiModelProperty("编号")
    @TableField("parent_id")
    private String parentId;

    @ApiModelProperty("访问时间")
    @TableField("access_time")
    private Date accessTime;

    @ApiModelProperty("载荷分辨率")
    @TableField("resolving_power")
    private BigDecimal resolvingPower;

    @ApiModelProperty("侧摆")
    @TableField("side_sway_value")
    private BigDecimal sideSwayValue;

    @ApiModelProperty("幅宽")
    @TableField("cloth_with")
    private BigDecimal clothWith;

    @ApiModelProperty("覆盖率")
    @TableField("coverage")
    private Float coverage;

    @ApiModelProperty("俯仰角")
    @TableField("pitch_angle")
    private Float pitchAngle;

    @ApiModelProperty("太阳高度角")
    @TableField("sun_angle")
    private Double sunAngle;

    @ApiModelProperty("备注类型，0：正常，1：月影，2：地影，3：日凌")
    private Integer remarkType;

    @ApiModelProperty("备注类型，0：正常，1：月影，2：地影，3：日凌")
    private String remark;

}
