package com.base.plan.model.param;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * @program: server
 * @description: 筹划方案请求参数类
 * @author: jojo
 * @create: 2024-10-08 14:17
 **/
@Data
public class DemandParam {

    /**
     * 目标parentId集合
     */
    @ApiModelProperty(value = "目标parentId集合")
    private List<String> parentIds;

    /**
     * 筹划方案需求类型，0：根据目标parentId集合进行筹划方案生成，1：根据parentId中第一条数据进行全部目标的筹划方案生成
     */
    @ApiModelProperty(value = "筹划方案需求类型，0：根据目标parentId集合进行筹划方案生成，1：根据parentId中第一条数据进行全部目标的筹划方案生成")
    private String demandType;
}
