package com.base.track;

import com.alibaba.druid.spring.boot.autoconfigure.DruidDataSourceAutoConfigure;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import java.util.TimeZone;

@EnableDiscoveryClient
@ComponentScan(basePackages = {"com.base"})
@MapperScan("com.base.track.mapper")
@EnableTransactionManagement
@SpringBootApplication(exclude = {DruidDataSourceAutoConfigure.class})
@EnableFeignClients(basePackages = {"com.base.api.client","com.plan.api.client"})
public class TrackApplication {

    public static void main(String[] args) {
        new SpringApplicationBuilder(TrackApplication.class).run(args);
    }
}