package com.base.track.model.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

@Data
@EqualsAndHashCode(callSuper = false)
@TableName("base_eph_data")
public class EphData {

    @TableId
    private Long id;

    @ApiModelProperty(value = "卫星编号")
    private String code;

    @ApiModelProperty(value = "星历数据时间")
    private Date ephTime;

    @ApiModelProperty(value = "X")
    @TableField("X")
    private BigDecimal X;

    @ApiModelProperty(value = "Y")
    @TableField("Y")
    private BigDecimal Y;

    @ApiModelProperty(value = "Z")
    @TableField("Z")
    private BigDecimal Z;

    @ApiModelProperty(value = "VX")
    @TableField("VX")
    private BigDecimal VX;

    @ApiModelProperty(value = "VY")
    @TableField("VY")
    private BigDecimal VY;

    @ApiModelProperty(value = "VZ")
    @TableField("VZ")
    private BigDecimal VZ;

    @ApiModelProperty(value = "圈号")
    private String cirCle;

}
