package com.base.track.model.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author cxl
 * @since 2022-06-20
 */
@Data
@NoArgsConstructor
@EqualsAndHashCode(callSuper = false)
@TableName("subpoint")
@ApiModel(value = "SubPointData对象")
public class SubPointData implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("id")
    @TableId("id")
    private String id;

    @ApiModelProperty("卫星id")
    @TableField("satellite_id")
    private String satelliteId;

    @ApiModelProperty("卫星编号")
    @TableField("satellite_code")
    private String satelliteCode;


    @TableField("code")
    private String code;

    @ApiModelProperty("时间")
    @TableField("date")
    private Date date;

    @TableField("lat")
    private Double lat;

    @TableField("lon")
    private Double lon;

    @TableField("lr_lat")
    private Double lrLat;

    @TableField("lr_lon")
    private Double lrLon;

    @TableField("rr_lat")
    private Double rrLat;

    @TableField("rr_lon")
    private Double rrLon;

    @TableField("ls_lat")
    private Double lsLat;

    @TableField("ls_lon")
    private Double lsLon;

    @TableField("rs_lat")
    private Double rsLat;

    @TableField("rs_lon")
    private Double rsLon;

    @TableField("alt")
    private Double alt;

    @TableField("orbit")
    private String orbit;

    @TableField("updown")
    private String updown;

    //最接近的星下点
    @TableField("near_point_num")
    private int nearPointNum;

    //到地心距离
    @TableField("r")
    private double R;


}
